
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>《算法基础：打开算法之门》一3.5 快速排序 / iVAN</title>

    <meta name="description" content="《算法基础：打开算法之门》一3.5 快速排序 3.5 快速排序 像归并排序那样,快速排序也使用分治模式(因此也使用递归).然而,快速排序与归并排序所使用的分治法稍微有点不同.与归并排序相比,存在两个不同之处: ●快速排序按照原址工作. ●快速排序的渐近运行时间介于最坏情况和平均情况之间.尤其是,快速排序的最坏运行时间是Θ(n2),但是它的平均情况下的运行时间要更好一些:Θ(nlgn).快速排序也有好的常数因子(比归并排序更好一些),并且它通常是实践中的一个好的排序算法.这里是快速排序使用分治法的过程.再一次考虑对书架上的书进行排序的例子.就">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">《算法基础：打开算法之门》一3.5 快速排序</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h3>3.5 快速排序</h3>
<p>像归并排序那样，快速排序也使用分治模式（因此也使用递归）。然而，快速排序与归并排序所使用的分治法稍微有点不同。与归并排序相比，存在两个不同之处：<br />
●快速排序按照原址工作。<br />
●快速排序的渐近运行时间介于最坏情况和平均情况之间。尤其是，快速排序的最坏运行时间是Θ（n2），但是它的平均情况下的运行时间要更好一些：Θ（nlgn）。快速排序也有好的常数因子（比归并排序更好一些），并且它通常是实践中的一个好的排序算法。这里是快速排序使用分治法的过程。再一次考虑对书架上的书进行排序的例子。就像归并排序一样，最初我们考虑对位置从1～n的所有书进行排序，接着考虑更一般的情况：49对位置从p～r的书进行排序。1分解：首先选择位置在p～r之间的任意一本书，并称这本书为主元。对书架上的书进行重排以便排序在主元的作者名字之前的所有书籍或者是由同一个作者书写的书籍均放置在主元的左侧，排序在主元的作者名字之后的所有书籍均放置在主元的右侧。在这个例子中，我们在重排从位置9～位置15的所有书籍时，选择最右侧的书籍，即选择由Jack London所写的书籍作为主元：<br /><a href="https://yqfile.alicdn.com/122512d8becab5b33b8bc6c433bc0ff7a68f0da5.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzEyMjUxMmQ4YmVjYWI1YjMzYjhiYzZjNDMzYmMwZmY3YTY4ZjBkYTUucG5n.jpg"></a></p>
<p>经过重排后——我们称之为快速排序中的划分——由Flaubert和Dickens所写的书籍，即按照字母排序出现在London之前的，被放置在London所写的书籍的左侧，而其他的书籍，即按照字母排序出现在London之后的书籍，被放置在London所写的书籍的右侧。注意，划分后，被放置在London左侧的书籍是无序的，London右侧的书籍也是无序的。2解决：通过递归地对主元左侧的和右侧的书籍进行排序来求解子问题。也就是说，如果分解步骤将主元移动到位置q(例子中的位置11)，随后就会递归地对从位置p～位置q-1的书籍进行排序，同时递归地对从位置q+1～位置r的书籍进行排序。3合并：什么也不用做！一旦解决步骤递归地排序完成后，我们就完成任务了。为什么呢？所有在主元左侧的书籍（位于位置p～位置q的书籍）要么按照字母顺序均位于主元的前面，要么与主元有相同的作者，且已排好序，而所有在主元右侧的书籍（位于位置q+1～位置r的书籍）按照字母顺序均位于主元的后面，且已排好序。因此，从位置p～位置r的所有元素肯定是已经排好序了！如果将该书架改成数组并且将书籍改成数组元素，依然可以采用快速排序的策略。就像归并排序一样，50当待排序的子数组的元素数目少于两个时，基础情况就会发生。对于快速排序，假定我们调用了程序PARTITION(A,p,r)，而PARTITION(A,p,r)用于划分子数组A［pr］，且返回主元最终应放置的位置索引q。<br /><a href="https://yqfile.alicdn.com/002719a1eacd96488000ce3ab6d6c73327947111.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzAwMjcxOWExZWFjZDk2NDg4MDAwY2UzYWI2ZDZjNzMzMjc5NDcxMTEucG5n.jpg"></a></p>
<p>最初的调用是QUICKSORT(A,1,n)，这与归并排序MERGESORT程序类似。如下是递归如何展开的例子，其中每个子数组的索引p、q和r(其中p≤r)表示如下：</p>
<p><a href="https://yqfile.alicdn.com/51e4ef8b17dcf6ab121bb9287c50723fe439fe9a.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzUxZTRlZjhiMTdkY2Y2YWIxMjFiYjkyODdjNTA3MjNmZTQzOWZlOWEucG5n.jpg"></a></p>
<p>在数组每一位的最底端的值给出了最终要存储在该位置的元素。当你从左向右读入数组时，观察在每个位置处的值，你能看出数组确实是有序的。快速排序的关键是划分数组。就像能在Θ（n）时间归并n个元素一样，我们也能在Θ（n）时间划分n个元素。下面介绍如何将书架上位于位置p～位置r的书籍进行划分。选择集合中最右侧的书籍——在位置r处的书籍——作为主元。任意时刻，每本书将被精确地划分到这四个组的一个组中，且这些组均位于位置p～位置r之间，从左到右依次是：●组L(左侧组):这些书籍的作者名字按照字母排序出现在主元之前或者跟主元的作者名字一致。●组R(右侧组):排在组L之后，这些书籍的作者名字按照字母排序出现在主元之后。●组U(未知组):排在组R之后，这些书籍还没有检查，因此不知道它们的作者名字与主元的作者名字相比，排序如何。●组P(主元):排在组U之后，仅仅一本书，即主元。我们自左向右仔细检查组U中的书籍，将它与主元进行比较，并将它移动到组L中或者组R中，一旦检查到主元位置处，即终止所有操作。与主元进行比较的书籍始终是组U中最左侧的书籍。●如果这个书籍的作者名字按照字母排序位于主元的作者名字之后，那么这本书就成为组R中最右侧的书籍。由于这本书是组U中最左侧的书籍，并且组U紧跟在组R之后，我们仅仅需要将介于组R和组U之间的分割线向右移动一个位置，而无需移动其余任何书籍：<br /><a href="https://yqfile.alicdn.com/18d5f28cee02805f7d6ba277978681cda0e99018.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzE4ZDVmMjhjZWUwMjgwNWY3ZDZiYTI3Nzk3ODY4MWNkYTBlOTkwMTgucG5n.jpg"></a></p>
<p>●如果书籍的作者名字按照字母排序在主元的作者名字之前，或者等于主元的作者名字，那么我们就将这本书置为组L中最右侧的书籍。我们将它与组R中最左侧的书籍进行调换，并且将组L和组R之间的分割线向右移动一个位置，将组R和组U之间的分割线向右移动一个位置：<br /><a href="https://yqfile.alicdn.com/a3fad03fd2e908d93b8af4db411fc7a5f226e87e.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2EzZmFkMDNmZDJlOTA4ZDkzYjhhZjRkYjQxMWZjN2E1ZjIyNmU4N2UucG5n.jpg"></a></p>
<p>一旦判定到主元位置，我们将它与组R中最左侧的书籍进行调换。在我们这个例子中，我们在本节刚开始时显示了书籍的调整情况。我们将每本书与主元比较一次，当书籍的作者名字位于主元作者名字之前或者是等于主元的作者名字就会产生一次调换。因此，为了对n本书进行划分，我们至多进行n-1次比较（由于无需将主元和它本身比较）并且至多进行n次调换。注意，与归并排序不同，快速排序时我们能对书籍进行划分而无需将所有书籍从书架上取下来。也就是说，我们能对书籍进行原址划分。为了将划分书籍的操作转换成划分一个子数组A［pr］的操作，我们首先选择将A［r］（最右侧的书籍）作为主元。随后自左向右仔细检查子数组，将每个元素与主元进行比较。我们维持用于划分子数组的索引q和u如下：●子数组A［pq-1］对应着组L:每个元素小于或者等于主元。●子数组A［qu-1］对应着组R:每个元素均大于主元。●子数组A［ur-1］对应着组U:我们还不知道它们和主元的大小情况。●元素A［r］对应着组P:该位置上放置着主元。实际上，这一划分就是循环不变式。（我们不再证明。）53在每一步中，我们将组U中最左侧的元素A［u］和主元进行比较。如果A［u］比主元大，那么将u自增一来将组R和组U之前的分割线向右移动一个位置。如果反之，A［u］小于或者等于主元，那么将元素A［q］(组R中的最左侧元素)和A［u］进行调换，且分别将q和u自增一，这相当于将组L和组R之间的分割线以及组R和组U之间的分割线分别向右移动一个位置。PARTITION程序如下。<br /><a href="https://yqfile.alicdn.com/b7e3bc69bffcdf9815db00c98054bbad759ee133.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2I3ZTNiYzY5YmZmY2RmOTgxNWRiMDBjOTgwNTRiYmFkNzU5ZWUxMzMucG5n.jpg"></a></p>
<p>初始时刻，将q和u均赋值为p，组L(A［pq-1］)和组R(A［qu-1］)最初时均为空，且组U(A［ur-1］)包含除了主元之外的所有元素。在一些实例中，例如A［p］≤A［r］，会出现一个元素需要与它本身进行调换的情况，这个操作实际上对数组没有任何影响。第3步结束时会将主元元素和组R中最左侧的元素进行调换，因此会将主元移动到划分后的数组的正确位置上，并且随后会返回主元所在的新索引位置q。</p>
<p>下面解释PARTITION程序是如何在子数组A［510］上一步一步运行的，该数组是上面快速排序的例子里第一次划分得到的子数组。组U以白色表示，组L以浅阴影色表示，组R以深阴影色表示，组P（即主元）以最深的阴影色表示。下图的第一个序列表示了最初的数组和相应的索引，接下来的五步表示每次经过程序中第2步循环迭代后所得的序列（包括在每次迭代后将u自增1这一步骤），且最后一步得出了最终划分好的数组。</p>
<p><a href="https://yqfile.alicdn.com/e3a07a0af65f5181e1838f337c3ce51a4ee4ad46.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2UzYTA3YTBhZjY1ZjUxODFlMTgzOGYzMzdjM2NlNTFhNGVlNGFkNDYucG5n.jpg"></a></p>
<p>就像划分书籍一样，我们依次将每个元素和主元比较一次，并且每次比较中，我们至多进行一次调换。由于每次比较需花费常量时间，并且每次调换需要花费常量时间，因此对于具有n个元素的子数组进行PARTITION操作所需要的总时间是Θ（n）。那么QUICKSORT程序需要花费多长时间呢？就像归并排序一样，我们称对一个具有n个元素的子数组进行排序需要的时间为T(n)，即一个随着n增加而增长的函数。由PARTITION程序执行的分解操作需要花费Θ（n）时间。但是QUICKSORT所花费的时间依赖于划分操作得到的结果是否均匀。在最坏情况下，划分得到的大小是相当不平衡的。如果除了主元之外的所有元素均小于主元，那么PARTITION的结果是得到除去A［r］这个主元的剩余部分，且QUICKSORT最终会返回存储在变量q中的索引r值。这种情况下，A［q+1r］是空的，且A［pq-1］仅仅比A［pr］少一个元素。对空的子数组进行递归调用需要花费Θ（1）时间（即在第1步中进行调用和判定子数组是否为空时所花费的时间）。对于划分，我们可将Θ（1）并入Θ（n）时间内。但是如果A［pr］有n个元素，那么A［pq-1］有n-1个元素，因此对于A［pq-1］进行递归调用需要花费T(n-1)的时间。因此，我们得到递归式<a href="https://yqfile.alicdn.com/24e7abce008b75d722695dd0e8707b1380145d1f.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzI0ZTdhYmNlMDA4Yjc1ZDcyMjY5NWRkMGU4NzA3YjEzODAxNDVkMWYucG5n.jpg"></a><br />
我们无法利用主方法来计算这一递归式，但是它有解，即T(n)为Θ（n2）。这并不比选择排序更好一些！我们怎么会得到如此不均匀的划分呢？如果每一主元均比所有的其他元素大，那么虽然数组在开始时就已经是有序的了，55但是会得到一个不均匀的划分。如果数组初始时刻为逆序的，那么每次我们也会得到一个不均匀的划分。另一方面，如果每次我们都能得到一个均匀的划分，那么每个子数组将最多有n/2个元素。递归式将和34节最后针对归并排序的递归式一致，<a href="https://yqfile.alicdn.com/beeff6c09d0fdd2ae24ca186c1460249eb876fdf.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2JlZWZmNmMwOWQwZmRkMmFlMjRjYTE4NmMxNDYwMjQ5ZWI4NzZmZGYucG5n.jpg"></a><br />
采用同样的解法，T(n)是Θ（nlgn）。当然，如果遇到这种情况，我们是相当幸运的，或者我们也可以将输入数组进行特殊设计以使每次都能得到一个相对均匀的划分。在通常情况下，快速排序介于最好和最坏情况之间。理论分析过于繁琐，此时不一一推导证明，但是如果输入数组的元素随机产生，那么通常而言我们会得到一个相对均匀的划分，即QUICKSORT程序会花费Θ（nlgn）的运行时间。现在大胆设想一下。假定你的最大的敌人给你一个待排序的数组，并且已经知道你总是选择子数组的最后一个元素作为主元，且调整了数组的顺序以便你每次都会得到最坏情况下的划分。你会怎么对付你的敌人呢？这时，你可以首先判定初始数组是否为正序或者逆序，并在这种情况下做一些特殊处理。随后你的敌人可能再次将你的数组设计为每次都得到最坏情况下的划分，而不是偶尔是坏的划分。此时，你就不想对每种可能的坏的划分情况进行检查了。幸运的是，这里有一个更简单的解决方案：不要总是将最后一个元素选作主元。那么前述的可爱的PARTITION程序将不适合这种情况，因为各个组不再如假定的一样。这或许也不是个难题，在运行PARTITION程序之前，将A［r］和A［p…r］中那个被随机选定的元素进行调换即可。现在你已经随机选择了主元且能够继续执行该PARTITION程序。事实上，再稍稍努力，你将更容易得到一个接近均匀划分的情况。我们不再是从A［p…r］中随机选取一个元素作为主元，而是从A［p…r］中随机选取三个元素并将这三个元素的中位数和A［r］调换顺序。这里的中位数是指值介于另外两个元素之间的那个元素。（如果随机选择的元素中有两个或者更多的元素相等，那么我们会再随机地选择元素以消除这种情况。）再者，我不想让你面临这种情况，但是倘若你每次因选择随机元素而使得QUICKSORT花费比Θ（nlgn）更长的时间，你将是相当不幸的。而且，如果待排序的值都不同，那么除非你的敌人已经获取了你的随机数字产生器，否则你的敌人是无法控制你划分结果的均匀程度的。56QUICKSORT需要将元素调换多少次？那依赖于你是否将某元素“调换”至它本身的位置（即原地调整）看作是一次调换。你当然能够检查是否存在这种情况，并且如果存在的话，要避免这一调换。因此当且仅当一个元素确实因调换操作在数组中移动了位置，即PARTITION操作中当第2A步中q≠u或者当第3步中q≠r成立时，才被称作是一次调换。最少化调换次数的最好情况也是QUICKSORT渐近时间的一个最坏情况：当数组已经是有序时，那么没有调换操作发生。调换次数最多时等价于当n为偶数且数组类似于n,n-2,n-4,…,4,2,1,3,5,…,n-3,n-1。那么会产生n2/4次调换，且渐近运行时间也仍然是最坏情况Θ（n2）。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 17:17:28</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e7%b4%a2%e5%bc%95/" title="索引">索引</a>, <a href="https://www.iamivan.net/tag/https/" title="HTTPS">HTTPS</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e7%bb%84/" title="数组">数组</a>, <a href="https://www.iamivan.net/tag/%e7%ae%97%e6%b3%95/" title="算法">算法</a>, <a href="https://www.iamivan.net/tag/%e6%8e%92%e5%ba%8f/" title="排序">排序</a>, <a href="https://www.iamivan.net/tag/image/" title="image">image</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>《算法基础：打开算法之门》一3.5 快速排序的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYjqYxp.html" rel="bookmark">《算法基础：打开算法之门》一导读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 Algorithms Unlocked 计算机是如何解决问题的呢?小小的GPS是如何只在几秒钟内就从无数条可能路径中找出到达目的地的最快捷路径的呢?在网上购物时,又如何防止他人窃取你的信用卡账号呢?解决这些问题,以及大量其他问题的答案均是算法.我写本书的目的就是为你打开算法之门,解开算法之谜. 我是&lt;算法导论&gt;的合著者之一.&lt;算法导论&gt;是一本特别好的书(当然,这是我个人的主观评价),但是它确实相当专业. 本书并不是&lt;算法导论&gt;,甚至不能被称为一本教材.它既没有对计			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgPVQmp.html" rel="bookmark">《算法基础：打开算法之门》一1&period;2 资源利用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.2 资源利用 什么样的算法才能称为高效使用计算资源的算法呢?我们在讨论近似算法时提及了一个衡量效率的标准:时间.一个能给出正确输出但是会花费很长时间才能得出结果的算法可能是没有价值的.如果你的GPS需要一个小时才能计算出推荐的驾驶路线,你还会愿意打开GPS吗?诚然,一旦我们知道某算法能给出一个正确输出,时间便是我们用来衡量算法效率的主要方式.但是时间不是唯一的衡量标准.由于一个计算机算法必须能够在可用的内存空间上运行,因此我们可能还需要考虑该算法需要占用多大的计算机内存空间(它的&quot;内存占用量			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVwKyVb.html" rel="bookmark">《算法基础：打开算法之门》一第3章 排序算法和查找算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第3章 Algorithms Unlocked 排序算法和查找算法 在第2章中,我们看到了在数组上进行线性查找的三个算法.我们能做得更好吗?答案是:看情况.如果不清楚数组中的元素是否有序,我们是不可能做得更好的.在最坏情况下,我们必须查找数组的所有n个元素,因为如果在前n-1个元素中不能找到要找的值,那么要查找的元素可能在第n个位置上.因此,当我们不清楚数组中的元素是否有序时,我们不可能实现比Θ(n)更好的最坏情况运行时间. 然而,假定数组是以非递减顺序排序的,那么根据&quot;非递减&quot;的含义			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRN1vBM.html" rel="bookmark">《算法基础：打开算法之门》一2&period;1 如何描述计算机算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.1 如何描述计算机算法 将计算机算法描述成一个可执行程序可以有多种选择,例如使用通用的编程语言表示,像Java.C.C++.Python或Fortran.诚然,许多教科书上的算法都是这么表示的.但是使用实际的编程语言来表示算法所带来的问题是你可能会在语言细节上越陷越深,而对算法本身的认识反而模糊不清.另一种表示算法的方式是&quot;伪代码&quot;,就像我们在&lt;算法导论&gt;中使用的一样,它听起来像是多种编程语言和英语的混合表示.如果你曾用一种实际的编程语言编写过程序,那么你就能很容易地搞			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlRjlaz.html" rel="bookmark">数据结构与算法系列（2）基础排序算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 在计算机中实现存储数据最普遍的两种操作就是排序和查找.这是从计算机产业初始就已经确认的 了.这意味着排序和查找也是计算机科学领域最值得研究的两种操作.本书提到的许 多数据结构的主要设计目的就是为了使排序和/或查找更加简单,同时也是为了数据在结构内的存 储更加有效. 本章会介绍有关数据排序和查找的基础算法.这些算法仅依赖数组作为数据结构,而且所采用的 &quot;高级&quot;编程技术只是递归.本章还介绍了用来非正式分析不同算法之间速度与效率的方 法,此方法贯穿全书. 1.排序算法 人们在日常生活中			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrWX7Wp.html" rel="bookmark">程序员必须知道的10大基础实用算法及其讲解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				算法一:快速排序算法 快速排序是由东尼·霍尔所发展的一种排序算法.在平均状况下,排序 n 个项目要Ο(n log n)次比较.在最坏状况下则需要Ο(n2)次比较,但这种状况并不常见.事实上,快速排序通常明显比其他Ο(n log n) 算法更快,因为它的内部循环(inner loop)可以在大部分的架构上很有效率地被实现出来. 快速排序使用分治法(Divide and conquer)策略来把一个串行(list)分为两个子串行(sub-lists). 算法步骤: 1 从数列中挑出一个元素,称为 &quot;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgV0a1b.html" rel="bookmark">java-一道基础的算法，答案是什么？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 一道基础的算法,答案是什么? 看开始看算法(第四版) 第一张的一道练习 给出以下表达式的类型和值 d. 1+2+'3'**** 这个我觉得java是会自动转化为字符型吗? 我就自己println试验了一下. System.out.println(1+2+'3'); 结果为54,不懂了,求教. 但是我看了网上的答案是33?一样不懂 我已经知道了,题目中是我错误 原题是双引号,字符型 1+2+&quot;3&quot; 我看成1+2+'3'了.不过倒是加深了理解,谢谢各位 解决方案 带单引号的3是字			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlQXODp.html" rel="bookmark">程序员必须知道的10大基础实用算法及其讲解&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  算法一:快速排序算法 快速排序是由东尼·霍尔所发展的一种排序算法.在平均状况下,排序n个项目要Ο(nlogn)次比较.在最坏状况下则需要Ο(n2)次比较,但这种状况并不常见.事实上,快速排序通常明显比其他Ο(nlogn)算法更快,因为它的内部循环(innerloop)可以在大部分的架构上很有效率地被实现出来. 快速排序使用分治法(Divideandconquer)策略来把一个串行(list)分为两个子串行(sub-lists). 算法步骤: 1从数列中挑出一个元素,称为&quot;基准&quot;(p			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQryjKM.html" rel="bookmark">一道算法基础题 uva1586</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 一道算法基础题 uva1586 题目链接在这儿 http://uva.onlinejudge.org/index.php?option=com_onlinejudge&amp;Itemid=8&amp;category=830&amp;page=show_problem&amp;problem=4461 我自己做的代码如下 但是通不过 测了好多数据都没问题 #include&lt;cstdio&gt; #include&lt;cstring&gt; using namespace std; in			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVQBDVp.html" rel="bookmark">java 算法基础之二快速排序算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://www.cnblogs.com/hexiaochun/archive/2012/09/03/2668324.html java 算法基础之二快速排序算法 所谓的快速排序的思想就是,首先把数组的第一个数拿出来做为一个key,在前后分别设置一个i,j做为标识,然后拿这个key对这个数组从后面往前遍历,及j--,直到找到第一个小于这个key的那个数,然后交换这两个值,交换完成后,我们拿着这个key要从i往后遍历了,及i++;一直循环到i=j结束,当这里结束后,我们会发现大于这个key的值			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lpd7JXM.html" rel="bookmark" class="title">PS教你用色板快速制作一个多彩马赛克特效</a>
					<div>
						  原图: 临摹效果: 开整!新建一个600px*800px的文件. 底下的彩色格子要一个个画吗?我可不干这傻事!我的第六感告诉我,我以前在PS里看到过相似的东西--没错,就是色板~ 将色板截图,BT ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Vzwxe8b.html" rel="bookmark" class="title">jsp中通过数据流向客户端传送数据</a>
					<div>
						js|客户端|数据 jsp中通过数据流向客户端传送数据 /**@作者 : 慈勤强@Email : cqq1978@Gmail.com*/ 有人经常会问这样一个问题:&quot;服务器端程序如何向客户端 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YMRYX8b.html" rel="bookmark" class="title">concat 方法 &lpar;Array&rpar;</a>
					<div>
						  返回一个新数组,这个新数组是由两个或更多数组组合而成的. array1.concat([item1[, item2[, . . . [, itemN]]]]) 参数 array1 必选项.其他所有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9g9oz.html" rel="bookmark" class="title">怎么通过搜索引擎来做品牌营销</a>
					<div>
						搜索引擎营销顾名思义,就是引发互联网的用户去搜索,那么在SEO行业的发展今天.那我们在原来没有内容质量时候,我们是在竞争网站的关键词匹配以及靠大量的外链和关键词密度在做网站.在搜索引擎算法调整下.互联 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpP07Dp.html" rel="bookmark" class="title">把一个int数组的数字从小到大排列&lpar;C&num;&rpar;</a>
					<div>
						数组   using System; namespace ConsoleApplication1{ /// &lt;summary&gt; /// Class1 的摘要说明. /// &lt;/sum ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAxYZb.html" rel="bookmark" class="title">网站优化步入社交时代 百度&plus;新浪微博助你流量加倍</a>
					<div>
						大家好,不知这么长时间不见,是否还记得最科技呢,这段时间我们一直在关注互联网科技,抽空与A5的朋友再次探讨一下提升网站流量. 昨天,很多seoer们可能与我们最科技的工作人员一样,都注意到了一条消息, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRyNoKb.html" rel="bookmark" class="title">websphere性能优化</a>
					<div>
						从前年起客户的所有web容器都换成了websphere,版本是5.1.最初也不懂得性能优化,只是用ANT给Project打个war的包,通过WS的管理控制台发布上去就行了.但是客户在实际使用时,有时会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4wkQLp.html" rel="bookmark" class="title">与众不同windows phone &lpar;19&rpar;</a>
					<div>
						Device(设备)之陀螺仪传感器, Motion API 介绍 与众不同 windows phone 7.5 (sdk 7.1) 之设备 陀螺仪传感器 Motion API(运动 API) 示例 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk2n3yM.html" rel="bookmark" class="title">Photoshop中标尺单位怎么设置呢&quest;</a>
					<div>
						  Photoshop中标尺单位怎么设置呢? 1.打开我的ps软件 2.新建一个空白的画布 3.点击视图把标尺,显示出来 4.标尺被显示出来 5.我们点击编辑--首选项,----标尺 6.这里就能编辑 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVnPQ4z.html" rel="bookmark" class="title">用iSee打造美女立体感效果</a>
					<div>
						MM们在空间和博客展示自己的照片的时候,一直平铺的话,比较单调.iSee可以让照片有种飘起来的感觉,展示照片的时候有立体感,让人耳目一新.先看原图和效果图: 原图: 效果图: 操作步骤: iSee软件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPkgjM.html" rel="bookmark" class="title">Windows 7系统中怎样设置让软件不在状态栏显示</a>
					<div>
						我们首先来说一说常规的隐藏方法.首先切换到系统托盘,如图,有一个聊天软件,我不想让别人看见我聊天,想把它隐藏. 然后在托盘区域的空白处点击鼠标右键,然后点击属性. 在托盘区域属性设置中,点击一下自定义 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7vDwb.html" rel="bookmark" class="title">win7磁盘碎片清理功能强大</a>
					<div>
						Windows操作系统都有磁盘碎片整理这一功能,只是人们印象中,以往的Windows操作系统的磁盘碎片整理过程都非常的漫长,但是 Win7却有所不同,与之前的各种版本操作系统相比有着很大的提升.这主要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmGlyqb.html" rel="bookmark" class="title">人人桌面如何跟好友进行多人聊天&quest;</a>
					<div>
						在好友栏中,按下Ctrl键,选中想要聊天的好友,右键单击后,在弹出的菜单中选择&quot;邀请多人聊天&quot;. 您还可以建立整个好友组群聊:直接右键点击一个好友组的名字,在弹出的窗口中选择&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8naRb.html" rel="bookmark" class="title">巧用U盘为浏览器设密的绝招</a>
					<div>
						  Chrome是一款非常著名的浏览器软件.然而该浏览器没有主密码功能,这也就意味着任何使用您电脑的人都可以获得您的密码,例如信用卡密码.登录密码等. 在这里您可以找到使用主密码加密来保护您的Goog ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYRVe5p.html" rel="bookmark" class="title">高手教你巧解cpu温度过高问题</a>
					<div>
						  一.如何查看看CPU的稳定 利用硬件检测工具,比如360的硬件大师软件!开启这个软件就可以自动扫描,CPU问题.硬盘温度等信息,我们可以很清晰看到哪个硬件温度高!硬件检测工具方面鲁大师软件也非常不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZQaqz.html" rel="bookmark" class="title">ruby随机在控制台显示字符串</a>
					<div>
						require 'curses' module Curses def self.program main_scr=init_screen noecho cbreak curs_set(0) main_ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZdrKwM.html" rel="bookmark" class="title">udp-关于Java操作继电器的问题</a>
					<div>
						问题描述 关于Java操作继电器的问题 Java如何通过udp协议去操作继电器? 我用端口检测工具检测到的数据是正常的 但是就是发不到继电器上去! 还有一个问题是继电器只能识别16进制的数! 我该如何 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze60wwb.html" rel="bookmark" class="title">跪求大神给一个sql分类汇总语句</a>
					<div>
						问题描述 跪求大神给一个sql分类汇总语句 10C 现有两张表:Dept:ID DName ParentDept1 总经办 02 行政部 13 企划部 1Leave:ID UserName Udept ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrRmZM.html" rel="bookmark" class="title">三星手机调用相机拍照出现横竖屏切换&quest;</a>
					<div>
						问题描述 三星手机调用相机拍照出现横竖屏切换? 一个界面布局,有调用系统相机拍照功能,布局的Activity在Mainifest.xml文件里面设置为android:screenOrientation ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NvxyM.html" rel="bookmark" class="title">npm常用命令</a>
					<div>
						npm是一个node包管理和分发工具,已经成为了非官方的发布node模块(包)的标准.有了npm,可以很快的找到特定服务要使用的包,进行下载.安装以及管理已经安装的包. 1.npm install m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn79ZOz.html" rel="bookmark" class="title">企业版Windows Server 2003安装详细图解</a>
					<div>
						Windows Server http://www.aliyun.com/zixun/aggregation/19058.html&quot;&gt;2003是目前微软推出的使用最广泛的服务器操作系统 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvmrNVb.html" rel="bookmark" class="title">23种设计模式大全（适合新手阅读）</a>
					<div>
						原文:23种设计模式大全(适合新手阅读) 第Ⅰ部分 开篇     序章 第Ⅱ部分 创建型模式篇     第1章 单例模式(Single Pattern)     第2章 简单工厂模式(Sample F ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrX0mmz.html" rel="bookmark" class="title">MyEclipse10&period;6&sol;Eclipse4&period;2集成 flash builder 4&period;6</a>
					<div>
						1.安装 Myeclipse10.6或Eclipse 4.2 以及 Flash builder 4.6 2.运行FB安装目录下的可执行文件X:\Program Files\Adobe\Adobe Fl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYDQAp.html" rel="bookmark" class="title">jquery-foreach循环输出的checkbox，怎么将其设置为只能选中一个</a>
					<div>
						问题描述 foreach循环输出的checkbox,怎么将其设置为只能选中一个 代码如下: $(&quot;input.checkbox-store&quot;).on(&quot;click&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgOENM.html" rel="bookmark" class="title">java布局</a>
					<div>
						问题描述 如图,在第一部分中有若干标签,点击不同标签在第二部分的窗口中显示不同的内容界面,这样在java中应该如何去实现,最好能讲下实现方法,写个简单的例子,多谢[img=http://hiphoto ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2ZxmZb.html" rel="bookmark" class="title">饿了么完成新融资&comma;外卖平台迎来集体炫富时刻</a>
					<div>
						忙于补贴大战的外卖平台又迎来集体晒粮草的&quot;炫富&quot;时刻. 美团新一轮高达7亿美元的融资新闻尚难辨真假,早在2014年年底就不断爆出融资消息的外卖平台&quot;饿了么&quot;又被 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyW3Jvz.html" rel="bookmark" class="title">有没有懂给MQ加SSL的，用JMS的，网上不好查，求高手！！</a>
					<div>
						问题描述 项目组决定要在原有的MQ通信加入SSL,要我现在搭建起带SSL的MQ接受环境.是用JMS的.我的做法是1.在bindingfile加入SSLCIPHERSUITE(XXXXXXX),2.在w ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8KGKb.html" rel="bookmark" class="title">php正则匹配html中带class的div并选取其中内容的方法&lowbar;php技巧</a>
					<div>
						本文实例讲述了php正则匹配html中带class的div并选取其中内容的方法.分享给大家供大家参考.具体分析如下: 先看一段html代码: 复制代码 代码如下: &lt;div class=&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYN41rp.html" rel="bookmark" class="title">js实现仿Discuz文本框弹出层效果&lowbar;javascript技巧</a>
					<div>
						本文实例讲述了js实现仿Discuz文本框弹出层效果.分享给大家供大家参考.具体如下: 这是一个在经典论坛曾经热讨论的问题,记得在QQ邮箱里也有类似功能,Discuz7.0论坛里同样也有,当你的鼠标单 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNvAr7M.html" rel="bookmark" class="title">Oracle常用功能集锦&lowbar;FSO专题</a>
					<div>
						数值函数: abs(m) m的绝对值 mod(m,n) m被n除后的余数 power(m,n) m的n次方 round(m[,n]) m四舍五入至小数点后n位的值(n缺省为0) trunc(m[,n] ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
